-- Main.lua
-- Originally written by Rod, extended by Habna


import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

Version = Plugins["HugeBag"]:GetVersion();--> ** HugeBag current version **

AllVisible = true; --> All items are visible by default
IsSorting, IsMixing, IsMerging, IsMoving = false, false, false, false;
screenWidth, screenHeight = Turbine.UI.Display.GetSize(); --> ** Get the display size **
write = Turbine.Shell.WriteLine; --> To shorten the writeline command

--**v Detect Game Language v**
GLocale = "en";
if(Turbine.Shell.IsCommand("zusatzmodule")==true) then GLocale = "de";
elseif(Turbine.Shell.IsCommand("conseil")==true) then GLocale = "fr"; end
--**^

local Modesettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagMode" );

if Modesettings == nil then	Modesettings = {}; end
if Modesettings.Widget == nil then Modesettings.Widget = true; end
Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );

Widget = Modesettings.Widget;

-- import for both mode
import "HabnaPlugins.HugeBag";
import "HabnaPlugins.HugeBag.Class";

--**v Get player instance v**
if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
	Player = Turbine.Gameplay.LocalPlayer.GetInstance();
else
	Player = Turbine.Gameplay.LocalPlayer; --EU Version without November Patch
end
--**

Backpack = Player:GetBackpack();
backpackSize = Backpack:GetSize();
PN = Player:GetName();

PlayerVault = Turbine.PluginData.Load( Turbine.DataScope.Server, "HugeBagVault" );
if PlayerVault == nil then PlayerVault = {}; end
if PlayerVault[PN] == nil then PlayerVault[PN] = {}; end

PlayerSharedStorage = Turbine.PluginData.Load( Turbine.DataScope.Server, "HugeBagSharedSrorage" );
if PlayerSharedStorage == nil then PlayerSharedStorage = {}; end
if PlayerSharedStorage[PN] == nil then PlayerSharedStorage[PN] = {}; end

if Widget then import "HabnaPlugins.HugeBag.settingsWidget";
else import "HabnaPlugins.HugeBag.settingsWindow"; end
LoadSettings();

import "HabnaPlugins.HugeBag.color"; -- LUA color file
import "HabnaPlugins.HugeBag.functions"; -- LUA functions file
import "HabnaPlugins.HugeBag.sortingList"; -- LUA sorting list file
import "HabnaPlugins.HugeBag.sort"; -- LUA Sort file
import "HabnaPlugins.HugeBag.mix"; -- LUA Mix file
import "HabnaPlugins.HugeBag.search"; -- LUA Search file
import "HabnaPlugins.HugeBag.merge"; -- LUA Merge file
import "HabnaPlugins.HugeBag.itemsmenu"; -- LUA items Menu file
import "HabnaPlugins.HugeBag.OptionPanel"; -- LUA option panel file (for in-game plugin manage options tab)

if Widget then import "HabnaPlugins.HugeBag.mainWidget";
else import "HabnaPlugins.HugeBag.mainWindow"; end
frmMain = frmMain();

HugeBagCommand = Turbine.ShellCommand();

function HugeBagCommand:Execute( command, arguments )
	-- Commands for both mode
	if ( arguments == L["SCa1"] or arguments == "shb") then
		ShowHugeBag();
	elseif ( arguments == L["SCa2"] or arguments == "hhb") then
		HideHugeBag();
	elseif ( arguments == L["SCa3"] or arguments == "u") then
		UnloadHugeBag();
	elseif ( arguments == L["SCa4"] or arguments == "r") then
		ReloadHugeBag();
	elseif ( arguments == L["SCa5"] or arguments == "ra" ) then
		ResetSettings();
	elseif ( arguments == L["SCa6"] or arguments == "w" ) then
		ToggleWEsc();
	elseif ( arguments == L["SCa7"] or arguments == "v" ) then
		ToggleShow();
	elseif ( arguments == L["SCa8"] or arguments == "hbm" ) then
		ToggleMode();
	elseif ( arguments == L["SCa9"] or arguments == "aot" ) then
		ToggleAlwaysOnTop();
	elseif ( arguments == L["SCa10"] or arguments == "bv" ) then
		ToggleBotBarInfo("butvis");
	elseif ( arguments == L["SCa11"] or arguments == "si" ) then
		Sort();
	elseif ( arguments == L["SCa12"] or arguments == "mi" ) then
		Merge();
	elseif ( arguments == L["SCa13"] or arguments == "im" ) then
		InvMerge();
	elseif ( arguments == L["SCa14"] or arguments == "?" or arguments == "sc" ) then
		HelpInfo();
	elseif ( arguments == L["SCa15"] or arguments == "opt" ) then
		ShowOptionsMenu("nil");
	elseif ( arguments == "mix" ) then
		Mix();
	elseif ( arguments == "debug" ) then
		import "HabnaPlugins.HugeBag.debugwin";
		frmDebug();
	else
		SCNS = true;
	end

	if Widget then -- Commands for widget mode
		
	else -- Commands for window mode
		if ( arguments == L["SCa16"] or arguments == "rls" ) then
			ResetLSSettings();
		elseif ( arguments == L["SCa17"] or arguments == "sk" ) then
			ToggleSkin();
		elseif ( arguments == L["SCa18"] or arguments == "io" ) then
			ToggleItemsOrientation();
		elseif ( arguments == L["SCa19"] or arguments == "ls" ) then
			LockHugeBagSize();
		elseif ( arguments == L["SCa20"] or arguments == "lp" ) then
			LockHugeBagPosition();
		-- Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
		--elseif ( arguments == "reversefill" ) then
			--ToggleItemsReverseFill();
		else
			if SCNS then ShowNS = true; end
		end
	end
	
	if ShowNS then write( "HugeBag: " .. L["SC0"] ); SCNS= nil; ShowNS = nil; end -- Command not supported
end

Turbine.Shell.AddCommand( "HugeBag", HugeBagCommand );

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack6, false );

Turbine.Plugin.Load = function( self, sender, args )
	--write( L["HBLang"] ); --HugeBag Language
	--write( L["HBLoad"] ); --HugeBag version by Habna loaded!
end

Turbine.Plugin.Unload = function( self, sender, args )
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack6, true );
end