-- settingsWidget.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	InitXPos, InitYPos = 30, 30; --> ** Initial X & Y position of the first Item in the HugeBag **
	WinWidth, WinHeight = 449, 309; --> ** HugeBag initial size **
	winRate = 30; --> ** rate in screen pixel used to do the slide effect **
	windowOpen = false; --> ** Does widget is hidden are not ( true = showing, false = hidden ) **
	tL, tT = 100, 100; --> Default position for window
	
	if GLocale == "de" then	HBsettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWidgetSettingsDE" ); end
	if GLocale == "en" then HBsettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWidgetSettingsEN" ); end
	if GLocale == "fr" then	HBsettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWidgetSettingsFR" ); end
	
	if GLocale == "en" then	tA, tR, tG, tB = 0.3, 0.3, 0.3, 0.3;
	else tA, tR, tG, tB = "0,3", "0,3", "0,3", "0,3"; end

	if HBsettings == nil then HBsettings = {}; end
	
	if HBsettings.Language == nil then HBsettings.Language = GLocale; end
	HBLocale = HBsettings.Language;
	import ("HabnaPlugins.HugeBag.Locale."..HBLocale);
	

	if HBsettings.Location == nil then HBsettings.Location = {}; end
	if HBsettings.Location.Y == nil then HBsettings.Location.Y = string.format("%.3f", screenHeight - WinHeight - 69); end
	if HBsettings.Location.Loc == nil then HBsettings.Location.Loc = L["OWidLocR"]; end
	WinLocY = tonumber(HBsettings.Location.Y);
	WidgetLoc = HBsettings.Location.Loc;
	if WidgetLoc == "left" or WidgetLoc == "gauche" or WidgetLoc == "links" then WidgetLoc = L["OWidLocL"]; end
	if WidgetLoc == "right" or WidgetLoc == "droite" or WidgetLoc == "rechts" then WidgetLoc = L["OWidLocR"]; end

	-- **v Replace HugeBag if out of the screen on load v**
	if ( WinLocY + WinHeight ) > screenHeight then WinLocY = screenHeight - WinHeight end
	-- **^

	if HBsettings.BackColor == nil then HBsettings.BackColor = {}; end
	if HBsettings.BackColor.A == nil then HBsettings.BackColor.A = string.format("%.3f", tA); end
	if HBsettings.BackColor.R == nil then HBsettings.BackColor.R = string.format("%.3f", tR); end
	if HBsettings.BackColor.G == nil then HBsettings.BackColor.G = string.format("%.3f", tG); end
	if HBsettings.BackColor.B == nil then HBsettings.BackColor.B = string.format("%.3f", tB); end
	bcAlpha = tonumber(HBsettings.BackColor.A);
	bcRed = tonumber(HBsettings.BackColor.R);
	bcGreen = tonumber(HBsettings.BackColor.G);
	bcBlue = tonumber(HBsettings.BackColor.B);


	if HBsettings.Options == nil then	HBsettings.Options = {}; end
	if HBsettings.Options.StartVisible == nil then HBsettings.Options.StartVisible = false; end
	if HBsettings.Options.HideWEsc == nil then HBsettings.Options.HideWEsc = true; end
	if HBsettings.Options.AlwaysOnTop == nil then HBsettings.Options.AlwaysOnTop = false; end
	if HBsettings.Options.ShowSideBarInfo == nil then HBsettings.Options.ShowSideBarInfo = "image"; end
	if HBsettings.Options.ShowTopBarInfo == nil then HBsettings.Options.ShowTopBarInfo = "info"; end
	StartVisible = HBsettings.Options.StartVisible;
	HideWEsc = HBsettings.Options.HideWEsc;
	zOrder = HBsettings.Options.AlwaysOnTop;
	sidebarinfo = HBsettings.Options.ShowSideBarInfo;
	topbarinfo = HBsettings.Options.ShowTopBarInfo;


	if HBsettings.Button == nil then HBsettings.Button = {}; end
	if HBsettings.Button.InverseMerge == nil then HBsettings.Button.InverseMerge = false; end
	if HBsettings.Button.ShowButton == nil then HBsettings.Button.ShowButton = true; end
	InverseMerge = HBsettings.Button.InverseMerge;
	ShowButton = HBsettings.Button.ShowButton;
		

	if HBsettings.Button.Position == nil then HBsettings.Button.Position = {}; end
	if HBsettings.Button.Position.Sort == nil then HBsettings.Button.Position.Sort = string.format("%.0f", 0); end
	if HBsettings.Button.Position.Merge == nil then HBsettings.Button.Position.Merge = string.format("%.0f", 50); end
	local ts=0;
	if GLocale == "fr" then ts=30;
	elseif GLocale == "de" then ts=50; end
	if HBsettings.Button.Position.Search == nil then HBsettings.Button.Position.Search = string.format("%.3f", 100+ts); end
	SortLeft = tonumber(HBsettings.Button.Position.Sort);
	MergeLeft = tonumber(HBsettings.Button.Position.Merge);
	SearchLeft = tonumber(HBsettings.Button.Position.Search);
	

	if HBsettings.Vault == nil then HBsettings.Vault = {}; end
	if HBsettings.Vault.L == nil then HBsettings.Vault.L = string.format("%.0f", tL); end --X position of Vault window
	if HBsettings.Vault.T == nil then HBsettings.Vault.T = string.format("%.0f", tT); end --Y position of Vault window
	VWLeft = tonumber(HBsettings.Vault.L);
	VWTop = tonumber(HBsettings.Vault.T);


	if HBsettings.SharedStorage == nil then HBsettings.SharedStorage = {}; end
	if HBsettings.SharedStorage.L == nil then HBsettings.SharedStorage.L = string.format("%.0f", tL); end --X position of Shared Storage window
	if HBsettings.SharedStorage.T == nil then HBsettings.SharedStorage.T = string.format("%.0f", tT); end --Y position of Shared Storage window
	SSWLeft = tonumber(HBsettings.SharedStorage.L);
	SSWTop = tonumber(HBsettings.SharedStorage.T);


	if HBsettings.WasOpen == nil then HBsettings.WasOpen = false; end
	WasOpen = HBsettings.WasOpen;
	

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettingsDE", HBsettings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettingsEN", HBsettings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettingsFR", HBsettings ); end
end
-- **^
-- **v Save settings v**
function SaveSettings()
	HBsettings = {};
	HBsettings.WasOpen = WasOpen;

	HBsettings.Language = {};
	HBsettings.Language = HBLocale;

	HBsettings.Options = {};
	HBsettings.Options.StartVisible = StartVisible;
	if HBW then HBsettings.Options.StartVisible = true; end
	HBsettings.Options.HideWEsc = HideWEsc;
	HBsettings.Options.AlwaysOnTop = zOrder;
	HBsettings.Options.ShowSideBarInfo = sidebarinfo;
	HBsettings.Options.ShowTopBarInfo = topbarinfo;

	HBsettings.Location = {};
	--HBsettings.Location.X = tostring(WinLocX);
	HBsettings.Location.Y = tostring(WinLocY);
	HBsettings.Location.Loc = WidgetLoc;

	HBsettings.BackColor = {};
	HBsettings.BackColor.A = string.format("%.3f", bcAlpha);
	HBsettings.BackColor.R = string.format("%.3f", bcRed);
	HBsettings.BackColor.G = string.format("%.3f", bcGreen);
	HBsettings.BackColor.B= string.format("%.3f", bcBlue);

	HBsettings.Button = {};
	HBsettings.Button.InverseMerge = InverseMerge;
	HBsettings.Button.ShowButton = ShowButton;

	HBsettings.Button.Position = {};
	HBsettings.Button.Position.Sort = string.format("%.0f", SortLeft);
	HBsettings.Button.Position.Merge = string.format("%.0f", MergeLeft);
	HBsettings.Button.Position.Search = string.format("%.0f", SearchLeft);

	HBsettings.Vault = {};
	HBsettings.Vault.L = string.format("%.0f", VWLeft);
	HBsettings.Vault.T = string.format("%.0f", VWTop);

	HBsettings.SharedStorage = {};
	HBsettings.SharedStorage.L = string.format("%.0f", SSWLeft);
	HBsettings.SharedStorage.T = string.format("%.0f", SSWTop);

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettingsDE", HBsettings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettingsEN", HBsettings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettingsFR", HBsettings ); end

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset All settings v**
function ResetSettings()
	WinLocX = screenWidth - WinWidth - 1;
	WinLocY = screenHeight - WinHeight - 69;
	wHugeBag:SetPosition( WinLocX, WinLocY );
	WidgetLoc = L["OWidLocR"];
	StartVisible = false;
	WasOpen = false;
	HideWEsc = true;
	InverseMerge = false;
	Widget = Widget;
	if GLocale == "en" then tA, tR, tG, tB, tX = 0.3, 0.3, 0.3, 0.3;
	else tA, tR, tG, tB = "0,3", "0,3", "0,3", "0,3"; end
	bcAlpha, bcRed, bcGreen, bcBlue = tA, tR, tG, tB;
	wHugeBag.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	if windowOpen and not StartVisible then
		wHugeBag:SetVisible( true );
		slideCtr:SetWantsUpdates(true);
	end

	SortLeft, MergeLeft, SearchLeft = 0, 50, 100;
	if HBLocale == "fr" then SearchLeft = 130; end
	if HBLocale == "de" then SearchLeft = 150; end
	SortButton:SetPosition( SortLeft,  8 );
	SearchButton:SetPosition( SearchLeft,  8 );
	MergeButton:SetPosition( MergeLeft, 8 );
	zOrder = false;
	ToggleSideBarInfo("image");
	ToggleTopBarInfo("info");
	ShowButton = false;
	ToggleBotBarInfo("butvis");
	SaveSettings();
	write( L["SWidRA"] );
end
-- **^