-- HBsettings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	InitXPos, InitYPos = 17, 33; --> ** Initial X & Y position of the first Item in the HugeBag **
	WinWidth, WinHeight = 460, 300;
	edgePadding = 15; --> ** HugeBag initial edgePadding value **
	LockLabel = self; --> ** Label that prevents from moving the window cause it's located at top
	ClicX, ClicY = 0, 0; --> To know the x,y coord when mouse button was clic
	tL, tT = 100, 100; --> Default position for window

	if GLocale == "de" then	HBsettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWindowSettingsDE" ); end
	if GLocale == "en" then HBsettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWindowSettingsEN" ); end
	if GLocale == "fr" then	HBsettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWindowSettingsFR" ); end
	
	if HBsettings == nil then HBsettings = {}; end

	if HBsettings.Language == nil then HBsettings.Language = GLocale; end
	HBLocale = HBsettings.Language;
	import ("HabnaPlugins.HugeBag.Locale."..HBLocale);


	if HBsettings.Size == nil then HBsettings.Size = {}; end
	if HBsettings.Size.W == nil then HBsettings.Size.W = string.format("%.0f", 460); end
	if HBsettings.Size.H == nil then if backpackSize == 45 then HBsettings.Size.H = string.format("%.0f", 195);
	elseif backpackSize == 75 then HBsettings.Size.H = string.format("%.0f", 300);
	else HBsettings.Size.H = string.format("%.0f", 335); end end
	WinWidth = tonumber(HBsettings.Size.W);
	WinHeight = tonumber(HBsettings.Size.H);


	if HBsettings.Location == nil then HBsettings.Location = {}; end
	if HBsettings.Location.X == nil then HBsettings.Location.X = string.format("%.0f", Turbine.UI.Display.GetWidth() - edgePadding - WinWidth); end
	if HBsettings.Location.Y == nil then HBsettings.Location.Y = string.format("%.0f", Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55); end
	WinLocX = tonumber(HBsettings.Location.X);
	WinLocY = tonumber(HBsettings.Location.Y);

	-- Need to go out of bound when no skin on HugeBag
	-- **v Replace HugeBag if out of the screen on load v**
	--if ( WinLocX + WinWidth ) > screenWidth then WinLocX = screenWidth - WinWidth end
	--if ( WinLocY + WinHeight ) > screenHeight then WinLocY = screenHeight - WinHeight end
	-- **^
	

	if HBsettings.BackColor == nil then HBsettings.BackColor = {}; end
	if HBsettings.BackColor.A == nil then HBsettings.BackColor.A = string.format("%.3f", 1); end
	if HBsettings.BackColor.R == nil then HBsettings.BackColor.R = string.format("%.3f", 0); end
	if HBsettings.BackColor.G == nil then HBsettings.BackColor.G = string.format("%.3f", 0); end
	if HBsettings.BackColor.B == nil then HBsettings.BackColor.B = string.format("%.3f", 0); end
	bcAlpha = tonumber(HBsettings.BackColor.A);
	bcRed = tonumber(HBsettings.BackColor.R);
	bcGreen = tonumber(HBsettings.BackColor.G);
	bcBlue = tonumber(HBsettings.BackColor.B);
	

	if HBsettings.Options == nil then	HBsettings.Options = {}; end
	if HBsettings.Options.StartVisible == nil then HBsettings.Options.StartVisible = false; end
	--if HBsettings.Options.ShowSlotsInfo == nil then HBsettings.Options.ShowSlotsInfo = true; end
	if HBsettings.Options.TopSection == nil then HBsettings.Options.TopSection = "info"; end
	if HBsettings.Options.HideWEsc == nil then HBsettings.Options.HideWEsc = true; end
	if HBsettings.Options.LockPosition == nil then HBsettings.Options.LockPosition = false; end
	if HBsettings.Options.LockSize == nil then HBsettings.Options.LockSize = false; end
	if HBsettings.Options.ShowSkin == nil then HBsettings.Options.ShowSkin = true; end
	if HBsettings.Options.AlwaysOnTop == nil then HBsettings.Options.AlwaysOnTop = false; end
	if HBsettings.Options.InverseMerge == nil then HBsettings.Options.InverseMerge = false; end -- True => Merge for slot 1 to last slot in bag
	if HBsettings.Options.HorizontalOrientation == nil then HBsettings.Options.HorizontalOrientation = true; end
	if HBsettings.Options.ReverseFill == nil then HBsettings.Options.ReverseFill = false; end
	StartVisible = HBsettings.Options.StartVisible;
	topbarinfo = HBsettings.Options.TopSection;
	HideWEsc = HBsettings.Options.HideWEsc;
	LockPosition = HBsettings.Options.LockPosition;
	LockSize = HBsettings.Options.LockSize;
	ShowSkin = HBsettings.Options.ShowSkin;
	zOrder = HBsettings.Options.AlwaysOnTop;
	InverseMerge = HBsettings.Options.InverseMerge;
	HorizontalOrientation = HBsettings.Options.HorizontalOrientation;
	ReverseFill = HBsettings.Options.ReverseFill;


	if HBsettings.Language == nil then HBsettings.Language = GLocale; end
	HBLocale = HBsettings.Language;
	import ("HabnaPlugins.HugeBag.Locale."..HBLocale);
	

	if HBsettings.Button == nil then HBsettings.Button = {}; end
	if HBsettings.Button.Show == nil then HBsettings.Button.Show = true; end
	if HBsettings.Button.AtTop == nil then HBsettings.Button.AtTop = false; end
	if HBsettings.Button.AtLeft == nil then HBsettings.Button.AtLeft = true; end
	ShowButton = HBsettings.Button.Show;
	ButtonAtTop = HBsettings.Button.AtTop;
	ButtonAtLeft = HBsettings.Button.AtLeft;
	

	if HBsettings.Button.Position == nil then	HBsettings.Button.Position = {}; end
	if HBsettings.Button.Position.Sort == nil then HBsettings.Button.Position.Sort = string.format("%.3f", 0); end
	if HBsettings.Button.Position.Merge == nil then HBsettings.Button.Position.Merge = string.format("%.3f", 50); end
	local ts=0;
	if GLocale == "fr" then ts=30;
	elseif GLocale == "de" then ts=50; end
	if HBsettings.Button.Position.Search == nil then HBsettings.Button.Position.Search = string.format("%.3f", 100+ts); end
	SortLeft = tonumber(HBsettings.Button.Position.Sort);
	MergeLeft = tonumber(HBsettings.Button.Position.Merge);
	SearchLeft = tonumber(HBsettings.Button.Position.Search);


	if HBsettings.Vault == nil then HBsettings.Vault = {}; end
	if HBsettings.Vault.L == nil then HBsettings.Vault.L = string.format("%.0f", tL); end --X position of Vault window
	if HBsettings.Vault.T == nil then HBsettings.Vault.T = string.format("%.0f", tT); end --Y position of Vault window
	VWLeft = tonumber(HBsettings.Vault.L);
	VWTop = tonumber(HBsettings.Vault.T);


	if HBsettings.SharedStorage == nil then HBsettings.SharedStorage = {}; end
	if HBsettings.SharedStorage.L == nil then HBsettings.SharedStorage.L = string.format("%.0f", tL); end --X position of Shared Storage window
	if HBsettings.SharedStorage.T == nil then HBsettings.SharedStorage.T = string.format("%.0f", tT); end --Y position of Shared Storage window
	SSWLeft = tonumber(HBsettings.SharedStorage.L);
	SSWTop = tonumber(HBsettings.SharedStorage.T);
	

	if HBsettings.WasVisible == nil then HBsettings.WasVisible = StartVisible; end
	WasVisible = HBsettings.WasVisible;


	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettingsDE", HBsettings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettingsEN", HBsettings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettingsFR", HBsettings ); end
end
-- **^
-- **v Save settings v**
function SaveSettings()
	HBsettings = {};
	HBsettings.WasVisible = WasVisible;

	HBsettings.Language = {};
	HBsettings.Language = HBLocale;

	HBsettings.Location = {};
	HBsettings.Location.X = string.format("%.0f", WinLocX);
	HBsettings.Location.Y = string.format("%.0f", WinLocY);

	HBsettings.Size = {};
	HBsettings.Size.W = string.format("%.0f", WinWidth);
	HBsettings.Size.H = string.format("%.0f", WinHeight);

	HBsettings.Options = {};
	HBsettings.Options.StartVisible = StartVisible;
	--HBsettings.Options.ShowSlotsInfo = ShowSlotsInfo;
	HBsettings.Options.TopSection = topbarinfo;
	HBsettings.Options.HideWEsc = HideWEsc;
	HBsettings.Options.LockPosition = LockPosition;
	HBsettings.Options.LockSize = LockSize;
	HBsettings.Options.ShowSkin = ShowSkin;
	HBsettings.Options.AlwaysOnTop = zOrder;
	HBsettings.Options.InverseMerge = InverseMerge;
	HBsettings.Options.HorizontalOrientation = HorizontalOrientation;
	HBsettings.Options.ReverseFill = ReverseFill;

	HBsettings.Language = {};
	HBsettings.Language = HBLocale;

	HBsettings.BackColor = {};
	HBsettings.BackColor.A = string.format("%.3f", bcAlpha);
	HBsettings.BackColor.R = string.format("%.3f", bcRed);
	HBsettings.BackColor.G = string.format("%.3f", bcGreen);
	HBsettings.BackColor.B = string.format("%.3f", bcBlue);
	
	HBsettings.Button = {};
	HBsettings.Button.Show = ShowButton;
	HBsettings.Button.AtTop = ButtonAtTop;
	
	HBsettings.Button.Position = {};
	HBsettings.Button.Position.Sort = string.format("%.0f", SortLeft);
	HBsettings.Button.Position.Merge = string.format("%.0f", MergeLeft);
	HBsettings.Button.Position.Search = string.format("%.0f", SearchLeft);

	HBsettings.Vault = {};
	HBsettings.Vault.L = string.format("%.0f", VWLeft);
	HBsettings.Vault.T = string.format("%.0f", VWTop);

	HBsettings.SharedStorage = {};
	HBsettings.SharedStorage.L = string.format("%.0f", SSWLeft);
	HBsettings.SharedStorage.T = string.format("%.0f", SSWTop);

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettingsDE", HBsettings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettingsEN", HBsettings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettingsFR", HBsettings ); end

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset Location and Size settings v**
function ResetLSSettings()
	WinWidth = 460;
	if backpackSize == 45 then WinHeight = 195;
	elseif backpackSize == 75 then WinHeight = 300;
	elseif backpackSize == 90 then WinHeight = 335; end
	
	wHugeBag:SetSize( WinWidth, WinHeight );
	wHugeBag:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = wHugeBag:GetPosition();
	wHugeBag:SetVisible( true );
	if not ButtonAtLeft then
		if ( self:GetWidth() >= 218 ) then
			ButtonsLeft();
			ButtonsRight();
		end
	end
	PerformLayout();
	PrintTitle();
	SaveSettings();
	Turbine.Shell.WriteLine( L["SWinRLS"] );
end
-- **^
-- **v Reset All settings v**
function ResetSettings()
	StartVisible = false;
	HBWasVisible = false;
	--ShowSlotsInfo = true;
	topbarinfo = "info";
	HideWEsc = true;
	LockPosition = false;
	LockLabel.Enable = false;
	LockSize = false;
	Widget = Widget;
	WinWidth = 460;
	if backpackSize == 45 then WinHeight = 195;
	elseif backpackSize == 75 then WinHeight = 300;
	elseif backpackSize == 90 then WinHeight = 335; end
	wHugeBag:SetSize( WinWidth, WinHeight );
	wHugeBag:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = wHugeBag:GetPosition();
	bcAlpha, bcRed, bcGreen, bcBlue = 1, 0, 0, 0;
	wHugeBag.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	ShowSkin = false;
	ToggleSkin();
	ShowButton = true;
	--ToggleButton();
	ButtonAtTop = false;
	--ButtonAtLeft = true;
	--ButtonsPos = "left";
	InverseMerge = false;
	SortLeft, MergeLeft, SearchLeft = 0, 50, 100;
	if HBLocale == "fr" then SearchLeft = 130; end
	if HBLocale == "de" then SearchLeft = 150; end
	HorizontalOrientation = true;
	--ReverseFill = false;
	zOrder = false;
	PerformLayout();
	PrintTitle();
	SaveSettings();
	write( L["SWidRA"] );
end
-- **^