-- sharedstorage.lua
-- written by Habna


function frmSharedStorage()
	--wStorage = Turbine.UI.Window();
	wStorage = Turbine.UI.Lotro.Window()
	--wStorage = Turbine.UI.Lotro.GoldWindow()
	
	wStorage.cursor = nil;

	-- **v Set backcolor, position, size and text of the window v**
	wStorage:SetWidth( 460 );
	wStorage:SetPosition( VWLeft, VWTop );
	wStorage:SetText( L["OWidStorage"] );
	wStorage:SetWantsKeyEvents( true );
	wStorage:SetVisible( true );
	vWinWidth, vWinHeight = wStorage:GetSize();
	listWidth = vWinWidth - 37;
	--wStorage:SetZOrder( 2 );
	--wStorage:Activate();

	wStorage.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wStorage:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wStorage:SetVisible( not wStorage:IsVisible() );
		end
	end

	wStorage.MouseUp = function( sender, args )
		HBsettings.SharedStorage.L = string.format("%.0f", wStorage:GetLeft());
		HBsettings.SharedStorage.T = string.format("%.0f", wStorage:GetTop());
		SSWLeft, SSWTop = wStorage:GetPosition();
		SaveSettings();
	end

	wStorage.Closing = function( sender, args ) -- Function for the Upper right X icon
		option_sharedstorage:SetEnabled( true );
		wStorage = nil;
	end
	-- **^
	
	-- **v Set the itemlistbox v**
	wStorage.ListBox = Turbine.UI.ListBox();
	wStorage.ListBox:SetParent( wStorage );
	wStorage.ListBox:SetPosition( 17, 35 );
	wStorage.ListBox:SetWidth( listWidth );
	wStorage.ListBox:SetMaxItemsPerLine( 12 );
	wStorage.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wStorage.ListBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	--**^

	-- **v Set the scrollbar v**
	wStorage.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	wStorage.ListBoxScrollBar:SetParent( wStorage );
	wStorage.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wStorage.ListBox:SetVerticalScrollBar( wStorage.ListBoxScrollBar );
	wStorage.ListBoxScrollBar:SetPosition( vWinWidth - 20, 40 );
	wStorage.ListBoxScrollBar:SetSize( 10, wStorage.ListBox:GetHeight() - 15 );
	-- **^

	-- **v Get player gameplay v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		storagepack = Turbine.Gameplay.LocalPlayer.GetInstance():GetSharedStorage();
	else
		storagepack = Turbine.Gameplay.LocalPlayer():GetSharedStorage();
	end
	-- **^

	storagepackSize = storagepack:GetCapacity();
	--storagepackSize = 0; --debug purpose
	
	-- Convert the table key that is in string format into a number, so it can be viewed by lua correctly.
	if PlayerSharedStorage[PN] ~= nil then
		local newt = {}
		for k, v in pairs(PlayerSharedStorage[PN]) do newt[tonumber(k)] = v; end
		PlayerSharedStorage[PN] = newt;
	end
	
	if storagepackSize == 0 then --Shared Storage not loaded
		if #PlayerSharedStorage[PN] == 0 then --My Shared Storage item list is empty
			local lblmgs = Turbine.UI.Label();
			lblmgs:SetParent( wStorage );
			lblmgs:SetText( L["OWidNeed"]..L["OWidStorage"]..L["OWidOnce"] );
			lblmgs:SetPosition( 30, 50 );
			lblmgs:SetSize( lblmgs:GetTextLength() * 7.5, 15 );
			lblmgs:SetForeColor( green );
			lblmgs:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );

			wStorage.ListBox:SetHeight( 0 );
			wStorage.ListBox:SetVisible( false );
			wStorage:SetSize( lblmgs:GetWidth()+60, lblmgs:GetHeight()+60 );
		else
			storagepackSize = tonumber(PlayerSharedStorage[PN][1].Z);
			storagepackcount = 0;
			Setstoragepack();
		end
	else
		storagepackcount = storagepack:GetCount();
		PlayerSharedStorage[PN] = {};

		for ii = 1, storagepackcount do
			PlayerSharedStorage[PN][tostring(ii)] = storagepack:GetItem( ii );
			local iteminfo = PlayerSharedStorage[PN][tostring(ii)]:GetItemInfo();
			
			PlayerSharedStorage[PN][tostring(ii)].Q = tostring(iteminfo:GetQualityImageID());
			PlayerSharedStorage[PN][tostring(ii)].B = tostring(iteminfo:GetBackgroundImageID());
			PlayerSharedStorage[PN][tostring(ii)].U = tostring(iteminfo:GetUnderlayImageID());
			PlayerSharedStorage[PN][tostring(ii)].S = tostring(iteminfo:GetShadowImageID());
			PlayerSharedStorage[PN][tostring(ii)].I = tostring(iteminfo:GetIconImageID());
			local tq = tostring(PlayerSharedStorage[PN][tostring(ii)]:GetQuantity());
			if tq == "1" then tq = ""; end
			PlayerSharedStorage[PN][tostring(ii)].N = tq;
			PlayerSharedStorage[PN][tostring(ii)].Z = tostring(storagepackSize);
		end

		Turbine.PluginData.Save( Turbine.DataScope.Server, "HugeBagSharedSrorage", PlayerSharedStorage );
		Setstoragepack();
	end
end

--**v Set storagepack v**
function Setstoragepack()
	wStorage.items = nil;
	itemsCtl = nil;
	itemsLbl = nil;
	wStorage.ListBox:ClearItems();

	wStorage.items = {};
	itemsCtl = {};
	itemsLbl = {};

	-- Convert the table key that is in string format into a number, so it can be viewed by lua correctly.
	local newt = {}
	for k, v in pairs(PlayerSharedStorage[PN]) do newt[tonumber(k)] = v; end
	PlayerSharedStorage[PN] = newt;

	for i = 1, storagepackSize do
		-- Item background
		itemsCtl[i] = Turbine.UI.Control();
		itemsCtl[i]:SetSize( 35, 35 );
		itemsCtl[i]:SetBackground( resources.Item.Background );
		itemsCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Slot num in background
		itemsLbl[i] = Turbine.UI.Label();
		itemsLbl[i]:SetParent( itemsCtl[i] );
		itemsLbl[i]:SetSize( 35, 35 );
		itemsLbl[i]:SetPosition( 0, 0 );
		itemsLbl[i]:SetText( i );
		itemsLbl[i]:SetForeColor( verylightgrey );
		itemsLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		itemsLbl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		if PlayerSharedStorage[PN][i] ~= nil then
			-- Item Background/Underlay/Shadow/Image
			local itemBG = Turbine.UI.Control();
			itemBG:SetParent( itemsCtl[i] );
			itemBG:SetSize( 32, 32 );
			itemBG:SetPosition( 3, 3 );
			itemBG:SetBackground(tonumber(PlayerSharedStorage[PN][i].B));
			itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
			local itemU = Turbine.UI.Control();
			itemU:SetParent( itemsCtl[i] );
			itemU:SetSize( 32, 32 );
			itemU:SetPosition( 3, 3 );
			itemU:SetBackground(tonumber(PlayerSharedStorage[PN][i].U));
			itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local itemS = Turbine.UI.Control();
			itemS:SetParent( itemsCtl[i] );
			itemS:SetSize( 32, 32 );
			itemS:SetPosition( 3, 3 );
			itemS:SetBackground(tonumber(PlayerSharedStorage[PN][i].S));
			itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local item = Turbine.UI.Control();
			item:SetParent( itemsCtl[i] );
			item:SetSize( 32, 32 );
			item:SetPosition( 3, 3 );
			item:SetBackground(tonumber(PlayerSharedStorage[PN][i].I));
			item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			-- Item Quantity
			itemQTE = Turbine.UI.Label();
			itemQTE:SetParent( itemsCtl[i] );
			itemQTE:SetSize( 32, 15 );
			itemQTE:SetPosition( -4, 16 );
			itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
			itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
			itemQTE:SetOutlineColor( black );
			itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
			itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			itemQTE:SetForeColor( nicegold );
			itemQTE:SetText(tonumber(PlayerSharedStorage[PN][i].N));
			storagepackcount = storagepackcount+1;
		end

		wStorage.ListBox:AddItem( itemsCtl[i] );
	end

	--**v Set window v** --
	freeslots = storagepackSize - storagepackcount;
	wStorage:SetText( wStorage:GetText() .. " -- Free: " .. freeslots .. "  Used: " .. storagepackcount .. "  Max: " .. storagepackSize );
	if storagepackSize <= 75 then
		local tmpH = (math.ceil(storagepackSize/wStorage.ListBox:GetMaxItemsPerLine()))*35+3;
		wStorage.ListBox:SetHeight( tmpH );
		wStorage:SetHeight( wStorage.ListBox:GetTop()+wStorage.ListBox:GetHeight()+17 );
	else
		wStorage.ListBox:SetHeight( 248 );
		wStorage:SetHeight( 300 );
	end
end
-- **^